/* sc_strings.c
 * SommerCampus 2006
 * CStrings Kurs - Beispiel Bibliothek
 * Diese Bibliothek soll nur als Beispiel dienen und
 * versucht deshalb die GString Klasse der Glib Bibliothek (http://www.gtk.org/api/2.6/glib/glib-Strings.html)
 * zu kopieren/nachzumachen (nicht vollstndig)
 *
 * Licence: GPL-2 */


#include <sc_strings.h>

sc_strings *sc_strings_new(const char *init)
{
	size_t len;
	char *tmp;
	sc_strings *string;
	
	if(!init)
		return NULL;


	string = malloc(sizeof(sc_strings));

	if(!string)
		return NULL;
	
	len = strlen(init);

	tmp = malloc(len + 1);

	if(!tmp)
	{
		/* keinen Speicher fr die Zeichenkette */
		free(string);
		return NULL;
	}

	strcpy(tmp, init);

	string->str = tmp;
	string->len = len;
	string->size = len + 1;

	return string;
}

char *sc_strings_free(sc_strings *string, int content)
{
	char *str = NULL;
	if(!string)
		return NULL;

	if(content) 
		str = string->str;
	else
		free(string->str);

	/* nicht notwendig, aber Vorsicht ist besser als Nachsicht */

	string->str = NULL;
	string->len = string->size = 0;

	free(string);

	return str;
}
